'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { var object = _x3, property = _x4, receiver = _x5; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = createReactiveClass;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('./utils');

function createReactiveClass(tag) {
  var providerName = arguments.length <= 1 || arguments[1] === undefined ? 'ee' : arguments[1];
  var eventName = arguments.length <= 2 || arguments[2] === undefined ? 'props' : arguments[2];

  var ReactiveClass = (function (_React$Component) {
    _inherits(ReactiveClass, _React$Component);

    _createClass(ReactiveClass, [{
      key: 'addListener',
      value: function addListener(provider) {
        var _this = this;

        var listener = this.setState.bind(this);

        if (provider.on) {
          provider.on(eventName, listener);
          this.removeListener = function () {
            provider.removeListener(eventName, listener);
          };
        } else {
          (function () {
            var subscription = provider.subscribeOnNext(listener);
            _this.removeListener = function () {
              subscription.dispose();
            };
          })();
        }
      }
    }]);

    function ReactiveClass(props) {
      _classCallCheck(this, ReactiveClass);

      _get(Object.getPrototypeOf(ReactiveClass.prototype), 'constructor', this).call(this, props);
      this.displayName = 'ReactiveElement-' + tag;
      this.state = props;
    }

    _createClass(ReactiveClass, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.addListener(this.props[providerName]);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        if (nextProps[providerName] !== this.props[providerName]) {
          this.removeListener();
          this.addListener(nextProps[providerName]);
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.removeListener();
        this.removeListener = null;
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2['default'].createElement(tag, this.state, this.state.children);
      }
    }]);

    return ReactiveClass;
  })(_react2['default'].Component);

  ReactiveClass.propTypes = {};
  ReactiveClass.propTypes[providerName] = function (props, propName) {
    var provider = props[propName];
    if (!(0, _utils.isEventEmitter)(provider) && !(0, _utils.isRxObservable)(provider)) {
      return new Error(propName + ' must be an event emitter or Rx.Observable.');
    }
  };

  return ReactiveClass;
}

module.exports = exports['default'];